* Calculates an ABS position of the object (Left and Top). Used to position a form at
* exact location on the screen. Eg: under a button on the existing form etc. I use 
* this function for a "CboTree" control but, the same code exists as a method inside the 
* CboTree class.

LPARAMETERS toObject, tnLeft, tnTop
*
* toObject	-	reference to the object
* tnLeft	-	'Left' value for the object
* tnTop		-	'Top'  value for the object
*
* Returns: Left and Top values of the object in tnLeft and tnTop
*-----------------------------------------------------------------

IF type('toObject') <> 'O' OR ISNULL(toObject)
	RETURN ''
ENDIF 

LOCAL jcH as string, jn1 as integer, jcXobj as string, joForm as object

joForm = _Screen.Activeform
jcH = SYS(1272,toObject)	&& It will return: 'form1.pageframe1.page4.command2'
jcXobj = ''
jnObjects = GETWORDCOUNT(jcH,'.')
FOR jn1=1 TO jnObjects
	jcXobj = IIF(EMPTY(jcXobj),jcXobj+GETWORDNUM(jcH,jn1,'.'), jcXobj+'.'+GETWORDNUM(jcH,jn1,'.'))
	IF UPPER(LEFT(jcXobj,4)) = 'FORM' AND jn1 = 1
		jcXobj = 'joForm'
	ENDIF 
	jcBaseClass = UPPER(&jcXobj..BaseClass)
	DO case
		CASE jcBaseClass = 'FORM'
			tnLeft = tnLeft + &jcXobj..Left + SYSMETRIC(3)
			IF &jcXobj..TitleBar = 1
				tnTop  = tnTop  + &jcXobj..Top  + SYSMETRIC(4) + SYSMETRIC(9)
			ELSE
				tnTop  = tnTop  + &jcXobj..Top  + SYSMETRIC(4)
			ENDIF 
			
		CASE jcBaseClass = 'PAGEFRAME'
			tnLeft = tnLeft + &jcXobj..Left 
			IF &jcXobj..Tabs = .t.
				tnTop  = tnTop  + &jcXobj..Top + 26	&& PageFrame Tabs height = 26
			ELSE
				tnTop  = tnTop  + &jcXobj..Top
			ENDIF 
			
		CASE jcBaseClass = 'PAGE'
			*
			
		CASE jcBaseClass = 'CONTAINER'
			tnLeft = tnLeft + &jcXobj..Left 
			tnTop  = tnTop  + &jcXobj..Top 
			
		OTHERWISE 
			exit
	ENDCASE 
NEXT 
tnLeft = tnLeft + toObject.Left
tnTop  = tnTop  + toObject.Top
RETURN 